ver^1.6
#
#   HawkIRCd Configuration file - options.h
#   (C) 2001 Skyzer for the HawkIRCd.
#
# Follow the instructions here.
# 
# change the filename to what network header file you use
# relative to DPATH
Include .................: include/chatnet.network

#
# What K:Line address can K:lined users mail at?
#
Set KLINE_ADDRESS .......: kline@chatnet.com.br

# This is where your CHATNet WebPage
# is located
Set ECPA_ADDRESS ..........: http://www.chatnet.com.br

# In this line, the IRCd will die and give an error when it attempts to load the
# include/options.h 0 = continue 1 = Stop
Set CONFIG_FILE_STOP ....: 0

# If you want users to get auto +x on connect
# 1 = Yes 0 = No
Set MODE_X ..............: 1

# Auto +i users when they connect?
# 1 = Yes 0 = No
Set MODE_I ..............: 1

# Auto +G users when they connect? This can help as a new REMOVE_ADVERTISE
Set MODE_STRIPWORDS .....: 0

# If compiled on a halfhub network this will upgrade it to be a real hub
# *  else if tried on a leaf (not hub) it will cause an error
# 1 = Yes  0 = No

Set TRUEHUB .............: 0

#
# The IRCd won't boot if not this setting set correctly 
# RTFM and go thru the config file (this file)
# 1 = Yes  0 = No
Set CONFIG_FILE_STOP ....: 0

# 
# If to let non-opers do /stats O
#
#
Set SHOWOPERS ...........: 0

#
# This line allows you to set whether the new /kill format should be used. Then
# new format includes the server from which the /kill came from, the old format
# does not.
#
# If this line is set to 1 the new format will be used. If it is set to 0 then
# the standard format will be used. Note, if you set this to 1 then some users
# scripts may not function correctly, so if you want backwards compatibility set
# this to 0.
#
Set KILLDIFF ............: 1

#
# Show Oper MOTD at oper up?
# 1 = Yes 0 = No
Set SHOWOPERMOTD ........: 1

#
# Hide U:lines from non-opers in /links?
# 1 = Yes 0 = No
Set HIDE_ULINES .........: 1

#
# Allow use of ChatOps?
# 1 = Yes 0 = No
Set ALLOW_CHATOPS .......: 0

#
# What message do you want send to Z:lined SOCKS users?
#
Set SOCKS_BAN_MESSAGE ...: SOCKS server Detected

#
# What quit message do we want to send not yet Z:lined SOCKS users?
#
Set SOCKS_QUIT_MESSAGE ..: O uso de proxy no  permitido na rede CHATNet, para maiores informaes acesse nosso site.

#
# How many seconds will a insecure SOCKS be banned?
#
Set SOCKSBANTIME ........: 83400

#
# How many channels are users allowed to join?
#
Set MAXCHANNELSPERUSER ..: 20

#
# Will we support WebTV, NOTE replaces /NOTICE with a /PRIVMSG
# 1 = Yes 0 = No
Set WEBTV_SUPPORT .......: 0

#
# Should usermode +I (Total Invisibility) be disabled?
# 1 = Yes 0 = No
Set NO_OPER_HIDING ......: 1

#
# Should we make the user join a channel(s) on connect?
# 0 = No, if Yes, enter the channel name
# to make them join multiple channels seperate with ,s
# ex Set AUTO_JOIN_CHANS .....: #chan1,#chan2,#chan3
#
Set AUTO_JOIN_CHANS .....: 0

#
# Should we make the user join a channel(s) on /oper?
# 0 = No, if Yes, enter the channel name
# to make them join multiple channels seperate with ,s
# ex Set OPER_AUTO_JOIN_CHANS : #chan1,#chan2,#chan3
#
Set OPER_AUTO_JOIN_CHANS : 0

#
# This allows you specify the amount of time (in seconds)
# to wait for a DNS response. Set this to 0 to disable
# hostname resolving
#
Set HOST_TIMEOUT ........: 2

# 
# This allows you to specify the amount of retries
# that should be send when no DNS response is received
#
Set HOST_RETRIES ........: 2
